<?xml version="1.0" encoding="UTF-8"?>
<!--
  Copyright © 2014-2018 Cask Data, Inc.

  Licensed under the Apache License, Version 2.0 (the "License"); you may not
  use this file except in compliance with the License. You may obtain a copy of
  the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
  License for the specific language governing permissions and limitations under
  the License.
  -->

<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>

  <parent>
    <groupId>co.cask.cdap</groupId>
    <artifactId>cdap</artifactId>
    <version>5.2.0-SNAPSHOT</version>
  </parent>

  <artifactId>cdap-ui</artifactId>
  <name>CDAP UI</name>

  <properties>
    <app.main.class>co.cask.cdap.ui.ConfigurationJsonTool</app.main.class>
    <!--
      Note: Do not update this while bumping versions for a CDAP release.
      Only update this when releasing a new UI pack.
    -->
    <ui.pack.version>4.3.4_p7</ui.pack.version>
  </properties>

  <dependencies>
    <dependency>
      <groupId>co.cask.cdap</groupId>
      <artifactId>cdap-common</artifactId>
      <version>${project.version}</version>
    </dependency>
    <dependency>
      <groupId>co.cask.cdap</groupId>
      <artifactId>cdap-common</artifactId>
      <version>${project.version}</version>
      <type>test-jar</type>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>junit</groupId>
      <artifactId>junit</artifactId>
    </dependency>
    <dependency>
      <groupId>ch.qos.logback</groupId>
      <artifactId>logback-core</artifactId>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>ch.qos.logback</groupId>
      <artifactId>logback-classic</artifactId>
      <scope>test</scope>
    </dependency>
  </dependencies>

  <build>
    <plugins>
      <plugin>
        <artifactId>maven-clean-plugin</artifactId>
        <version>2.6.1</version>
        <configuration>
          <filesets>
            <fileset>
              <directory>node_modules</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>
            <fileset>
              <directory>dist</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>
            <fileset>
              <directory>cdap_dist</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>
            <fileset>
              <directory>login_dist</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>
            <fileset>
              <directory>common_dist</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>
            <fileset>
              <directory>node</directory>
              <followSymlinks>false</followSymlinks>
            </fileset>

          </filesets>
        </configuration>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-dependency-plugin</artifactId>
        <version>2.8</version>
        <executions>
          <execution>
            <id>copy-dependencies</id>
            <phase>prepare-package</phase>
            <goals>
              <goal>copy-dependencies</goal>
            </goals>
            <configuration combine.self="override">
              <outputDirectory>${stage.lib.dir}</outputDirectory>
              <overWriteReleases>false</overWriteReleases>
              <overWriteSnapshots>false</overWriteSnapshots>
              <overWriteIfNewer>true</overWriteIfNewer>
              <excludeGroupIds>org.apache.hbase,asm,org.apache.zookeeper,org.apache.kafka,org.apache.twill,\
                org.apache.httpcomponents,org.apache.thrift,org.apache.flume,org.apache.avro,org.ow2.asm,\
                com.google.inject,org.apache.hadoop,commons-codec,com.google.inject.extensions,\
                co.cask.http,org.codehaus.jackson</excludeGroupIds>
              <excludeArtifactIds>cdap-proto,tephra,zkclient,servlet-api,common-http,\
                common-lang,common-io</excludeArtifactIds>
              <prependGroupId>true</prependGroupId>
              <silent>true</silent>
              <includeScope>runtime</includeScope>
            </configuration>
          </execution>
        </executions>
      </plugin>
    </plugins>
    <pluginManagement>
      <plugins>
        <plugin>
          <groupId>org.apache.rat</groupId>
          <artifactId>apache-rat-plugin</artifactId>
          <version>0.10</version>
          <executions>
            <execution>
              <id>rat-check</id>
              <phase>validate</phase>
              <goals>
                <goal>check</goal>
              </goals>
              <configuration>
                <excludes>
                  <exclude>**/*.editorconfig</exclude>
                  <exclude>**/*.babelrc</exclude>
                  <exclude>**/*.jshintrc</exclude>
                  <exclude>**/*.jshintignore</exclude>
                  <exclude>**/*.eslintrc.json</exclude>
                  <exclude>**/*.eslintignore</exclude>
                  <exclude>**/*.stylelintignore</exclude>
                  <exclude>**/*.stylelintrc</exclude>
                  <exclude>**/*.svg</exclude>
                  <exclude>**/*__mocks__/**</exclude>
                  <exclude>**/bower_components/**</exclude>
                  <exclude>**/*.bowerrc</exclude>
                  <exclude>**/node_modules/**</exclude>
                  <exclude>**/coverage/**</exclude>
                  <exclude>**/dist/**</exclude>
                  <exclude>**/old_dist/**</exclude>
                  <exclude>**/common_dist/**</exclude>
                  <exclude>**/cdap_dist/**</exclude>
                  <exclude>**/login_dist/**</exclude>
                  <exclude>**/logs/**</exclude>
                  <exclude>**/npm-debug.log</exclude>
                  <exclude>**/node/**</exclude>
                  <exclude>**/*.json</exclude>
                  <exclude>**/*.lock</exclude>
                  <exclude>**/*.yaml</exclude>
                  <exclude>**/dll/**</exclude>
                  <exclude>**/LICENSE-node</exclude>
                  <exclude>**/cdap-ui-upgrade/**</exclude>
                </excludes>
              </configuration>
            </execution>
          </executions>
        </plugin>
      </plugins>
    </pluginManagement>
  </build>

  <profiles>
    <profile>
      <id>dist</id>
      <properties>
        <package.deb.depends>--depends cdap --replaces cdap-web-app --conflicts cdap-web-app --replaces 'cdap-ui (&lt;&lt; 3.4.0)'</package.deb.depends>
        <package.rpm.depends>--depends cdap --replaces cdap-web-app --conflicts cdap-web-app --replaces 'cdap-ui &lt; 3.4.0'</package.rpm.depends>
        <package.deb.arch>amd64</package.deb.arch>
        <package.rpm.arch>x86_64</package.rpm.arch>
        <ui.build.name>cdap-full-build</ui.build.name>
      </properties>
      <build>
        <plugins>
          <plugin>
            <groupId>com.github.eirslett</groupId>
            <artifactId>frontend-maven-plugin</artifactId>
            <version>1.6</version>
            <executions>
              <execution>
                <id>dist</id>
                <goals>
                  <goal>install-node-and-yarn</goal>
                </goals>
                <configuration>
                  <nodeVersion>v8.7.0</nodeVersion>
                  <yarnVersion>v1.2.1</yarnVersion>
                </configuration>
              </execution>
              <execution>
                <id>install-node-gyp</id>
                <goals>
                  <goal>yarn</goal>
                </goals>
                <configuration>
                  <arguments>global add node-gyp</arguments>
                </configuration>
              </execution>
              <execution>
                <id>yarn-install</id>
                <goals>
                  <goal>yarn</goal>
                </goals>
                <configuration>
                  <arguments>install --silent --frozen-lockfile</arguments>
                </configuration>
              </execution>
              <execution>
                <id>bower-install</id>
                <goals>
                  <goal>bower</goal>
                </goals>
                <configuration>
                  <arguments>install --allow-root</arguments>
                </configuration>
              </execution>
              <execution>
                <id>build-ui</id>
                <goals>
                  <goal>yarn</goal>
                </goals>
                <configuration>
                  <arguments>run ${ui.build.name}</arguments>
                </configuration>
              </execution>
              <execution>
                <id>clean-node-modules</id>
                <goals>
                  <goal>yarn</goal>
                </goals>
                <configuration>
                  <arguments>install --production --frozen-lockfile</arguments>
                </configuration>
              </execution>
              <execution>
                <id>remove-unnecessary-node-modules</id>
                <goals>
                  <goal>yarn</goal>
                </goals>
                <configuration>
                  <arguments>run clean-node-modules</arguments>
                </configuration>
              </execution>
            </executions>
          </plugin>
          <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>exec-maven-plugin</artifactId>
            <version>1.3.1</version>
            <executions>
              <execution>
                <id>clean-bower-components</id>
                <phase>process-resources</phase>
                <goals>
                  <goal>exec</goal>
                </goals>
                <configuration>
                  <executable>rm</executable>
                  <arguments>
                    <argument>-rf</argument>
                    <argument>bower_components</argument>
                  </arguments>
                </configuration>
              </execution>
            </executions>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-antrun-plugin</artifactId>
            <version>1.7</version>
            <executions>
              <execution>
                <id>copy-enterprise</id>
                <phase>process-resources</phase>
                <goals>
                  <goal>run</goal>
                </goals>
                <configuration>
                  <target>
                    <copy todir = "${stage.opt.dir}/server">
                      <fileset dir = "server" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/dist">
                      <fileset dir = "dist" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/old_dist">
                      <fileset dir = "old_dist" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/common_dist">
                      <fileset dir = "common_dist" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/cdap_dist">
                      <fileset dir = "cdap_dist" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/dll">
                      <fileset dir = "dll">
                        <exclude name="*development*" />
                      </fileset>
                    </copy>
                    <copy todir = "${stage.opt.dir}/login_dist">
                      <fileset dir = "login_dist" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/bin">
                      <fileset dir = "node">
                        <include name="node" />
                      </fileset>
                    </copy>
                    <copy todir = "${stage.opt.dir}/node_modules">
                      <fileset dir = "node_modules" />
                    </copy>
                    <copy todir = "${stage.opt.dir}/templates">
                      <fileset dir = "templates" />
                    </copy>
                    <copy todir = "${stage.opt.dir}">
                      <fileset dir = "./">
                        <include name="LICENSE-node" />
                      </fileset>
                    </copy>
                    <copy todir = "${stage.opt.dir}">
                      <fileset dir = "./">
                        <include name="package.json" />
                      </fileset>
                    </copy>
                    <copy todir = "${stage.opt.dir}">
                      <fileset dir = "./">
                        <include name="server.js" />
                      </fileset>
                    </copy>
                    <copy todir = "${stage.opt.dir}/cdap-ui-upgrade">
                      <fileset dir = "cdap-ui-upgrade" />
                    </copy>
                  </target>
                </configuration>
              </execution>
            </executions>
          </plugin>
        </plugins>
      </build>
    </profile>

    <profile>
      <id>rpm-prepare</id>
      <build>
        <plugins>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-resources-plugin</artifactId>
            <version>2.6</version>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-antrun-plugin</artifactId>
            <version>1.7</version>
          </plugin>
        </plugins>
      </build>
    </profile>

    <profile>
      <id>deb-prepare</id>
      <build>
        <plugins>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-resources-plugin</artifactId>
            <version>2.6</version>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-antrun-plugin</artifactId>
            <version>1.7</version>
          </plugin>
        </plugins>
      </build>
    </profile>

    <profile>
      <id>rpm</id>
      <build>
        <plugins>
          <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>exec-maven-plugin</artifactId>
            <version>1.3.1</version>
          </plugin>

          <!-- Extra deployment for rpm package. -->
          <!-- This has to be in child level, otherwise all modules would try to deploy. -->
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-deploy-plugin</artifactId>
            <version>2.8</version>
            <executions>
              <execution>
                <id>deploy-rpm</id>
                <phase>deploy</phase>
                <goals>
                  <goal>deploy-file</goal>
                </goals>
                <configuration>
                  <version>${project.version}</version>
                  <groupId>${dist.deploy.groupId}</groupId>
                  <artifactId>${project.artifactId}</artifactId>
                  <packaging>noarch.rpm</packaging>
                  <generatePom>false</generatePom>
                  <file>${project.build.directory}/${project.artifactId}-${package.version}-1.noarch.rpm</file>
                  <classifier>1</classifier>
                  <repositoryId>continuuity</repositoryId>
                  <url>${deploy.url}</url>
                </configuration>
              </execution>
            </executions>
          </plugin>
        </plugins>
      </build>
    </profile>

    <profile>
      <id>deb</id>
      <build>
        <plugins>
          <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>exec-maven-plugin</artifactId>
            <version>1.3.1</version>
          </plugin>

          <!-- Extra deployment for deb package -->
          <!-- This has to be in child level, otherwise all modules would try to deploy. -->
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-deploy-plugin</artifactId>
            <version>2.8</version>
            <executions>
              <execution>
                <id>deploy-deb</id>
                <phase>deploy</phase>
                <goals>
                  <goal>deploy-file</goal>
                </goals>
                <configuration>
                  <version>${project.version}</version>
                  <groupId>${dist.deploy.groupId}</groupId>
                  <artifactId>${project.artifactId}</artifactId>
                  <packaging>deb</packaging>
                  <generatePom>false</generatePom>
                  <file>${project.build.directory}/${project.artifactId}_${package.version}-1_all.deb</file>
                  <repositoryId>continuuity</repositoryId>
                  <url>${deploy.url}</url>
                </configuration>
              </execution>
            </executions>
          </plugin>
        </plugins>
      </build>
    </profile>

    <profile>
      <id>tgz</id>
      <build>
        <plugins>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-assembly-plugin</artifactId>
            <version>2.4</version>
          </plugin>

          <!-- Extra deployment for tgz package -->
          <!-- This has to be in child level, otherwise all modules would try to deploy. -->
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-deploy-plugin</artifactId>
            <version>2.8</version>
            <executions>
              <execution>
                <id>deploy-tgz</id>
                <phase>deploy</phase>
                <goals>
                  <goal>deploy-file</goal>
                </goals>
                <configuration>
                  <version>${project.version}</version>
                  <groupId>${dist.deploy.groupId}</groupId>
                  <artifactId>${project.artifactId}</artifactId>
                  <packaging>tar.gz</packaging>
                  <generatePom>false</generatePom>
                  <file>${project.build.directory}/${project.artifactId}-${package.version}.tar.gz</file>
                  <repositoryId>continuuity</repositoryId>
                  <url>${deploy.url}</url>
                </configuration>
              </execution>
            </executions>
          </plugin>
        </plugins>
      </build>
    </profile>

  </profiles>
</project>
